function printdata(data, sep)
	print('data, sep', data, sep)
	local izzr
	local prt = {}
	local function copytb(tb, ind)
		for i = 1, 8 do
			tb[i] = dig[ind][i]
		end 
	end
	for i = 1, 4 do
		izzr = string.sub(data, i, i)
		prt[i] = {}
		copytb(prt[i], izzr)
	end
	izzr = nil
	if sep == ":" then 
		if not dat.dotp then
			prt[2][4] = prt[2][4] + 1
			prt[2][6] = prt[2][6] + 1
			dat.dotp = true
		end
		dat.dot1 = prt[2][4]
		dat.dot2 = prt[2][6]
	end
	
	if sep == '.' then 
		prt[3][8] = prt[3][8] + 1 
	end
	max7219.write(prt)
	prt, copytb = nil, nil
end

function gettime()
	tm = rtctime.epoch2cal(rtctime.get()+dat.tz*60*60)
	local sh = tostring(tm.hour)
	local sm = tostring(tm.min)
	if #sh == 1 then sh = '0'.. sh end
	if #sm == 1 then sm = '0'.. sm end
	dat.lasttime = sh..sm
	if dat.mnow == dat.lasttime then
		if dat.dotp then
			dat.dotp = false
			dat.dot1 = bit.clear(dat.dot1, 0)
			dat.dot2 = bit.clear(dat.dot2, 0)
		else
			dat.dotp = true
			dat.dot1 = bit.set(dat.dot1, 0)
			dat.dot2 = bit.set(dat.dot2, 0)
		end
		max7219.sb(2,4,dat.dot1)
		max7219.sb(2,6,dat.dot2)
		return
	else
		dat.mnow = dat.lasttime
		printdata(dat.lasttime, ':')
	end
end

function maketemp(t, firstSign)
	if not tonumber(t) then 
		t = wth.maintemp or wth.apixu
		if not t then 
			return
		else
			tik:stop()
		end
	end
	
	if not firstSign then dat.tempernow = tonumber(t) end
	local sep = string.find(t,"%.") or 0
	local first = string.sub(t, 1, sep -1)
	local second = sep ==  0 and '0' or string.sub(t, sep+1, sep+1) or '0'
	second = second == '' and '0' or second
	if string.sub(first,1,1) == '-' then
		if #first == 2 then first = '-0'..string.sub(first,-1,-1) end
	else 
		if firstSign ~= 'H' then
			first = #first == 1 and '+0'..first or '+'..first
		end
	end
	if firstSign then first = firstSign..first end
	if #first ~= 4 then first = first..second end
	dat.mnow = first
	first, sep, second = nil, nil ,nil
	if not firstSign or firstSign == 'H' then
		printdata(dat.mnow, '.')
	else
		printdata(dat.mnow)
	end
end

tik = tmr.create()
tik:alarm(1000, 1, gettime)

tmrwth = tmr.create()
tmrwth:alarm(dat.int * 1000, 1, function()
	if tm.hour > 6 and tm.hour < 22 and not dat.intens then
		dat.intens = true
		max7219.setIntensity(11)
	elseif tm.hour >= 22 and dat.intens then
		dat.intens = false
		max7219.setIntensity(1)
	end
	print(node.heap())
	local tmranm = 2000
	if wth.maintemp or wth.apixu then 
		tik:stop() 
		if dat.anm then
			dat.call = maketemp
			if dat.askw%6 == 0 then
				tmranm = 3000
				dofile('moveupcall.lua')
			elseif dat.askw%3 == 0 then
				tmranm = 3000
				dofile('moveleftcall.lua')
			else
				dat.call = nil
				maketemp()
			end
		else
			maketemp()
		end
	end

	tmr.create():alarm(tmranm, 0, function(t)
		t = nil
		if wth.codef and wth.codef > 99 and wth.codef < 1283 then
			dofile('prtForecast.lua')
		else
			dofile('prtHome.lua')
		end
	end)
end)