if not (wifi.sta.getip()) then print('No WiFi!');return end
local key = "ВАШ_КЛЮЧ" -- !!!!!!!!!!!!!!!!!!!
local city = "Moscow" -- Ваш город !!!!!!!!!!
print(city)
if not dat then dat = {} end
if not wth then wth = {} end
if tm then
	tm = rtctime.epoch2cal(rtctime.get()+dat.tz*60*60)
	print('Now: '..tm.hour..':'..tm.min)
	if tm.hour > 18 then
		city = city..'&unixdt='..(rtctime.get())+12*60*60
	end
end

local answer = ''
local conn, getdata, killapixu 
local request = "GET http://api.apixu.com/v1/forecast.json?key="..key.."&q="..city.." HTTP/1.1\r\n"..	 
"Host: api.apixu.com\r\n"

getdata = function ()
	--print('answer:\n\n\n', answer,'\n\n')
	if answer == "" then 
		print('Lost answer!')
	else
		dat.err = string.find(answer,'error')
		if not dat.err then
			wth.maxtemp, wth.mintemp  = string.match(answer,'maxtemp_c":(%p*%d+.%d*),.+mintemp_c":(%p*%d+.%d*),"')
			wth.codenow, wth.codef = string.match(answer,'"code":(%d+).+"code":(%d+)')
			wth.apixu = string.match(answer,'temp_c":(%p*%d+.%d*),')
			wth.codef = tonumber(wth.codef) or 0
			print('Got Sky codes:', wth.codenow, wth.codef)
			print('Got Temp:', wth.apixu)
			print('Got Max:', wth.maxtemp,'Min:', wth.mintemp)
		else
			print('\t\t\tApixu Error!!!')
			dat.err = string.match(answer,'"message":"(.+)"') or 'Error.'
			dat.errcode = string.match(answer,'"code":(%d+)') or '0'
			print('\t\t\tApixu Says:', dat.err, dat.errcode)
		end
	end	
end


local _up_thsh = 3
local _skip_hd = true
local _chk = ''
local _cnt = 0
local i, j

local function cb_disconnected()
	--conn:close()
	conn = nil
	print('disconnected')
	getdata()
end

 local function data_received(c, data)
  	if killapixu then killapixu:stop(); killapixu:unregister();	killapixu = nil end
				
  if _skip_hd then
    _chk = _chk..data
     i, j = string.find(_chk, '\r\n\r\n')
    if i then
      _skip_hd = false
      data = string.sub(_chk, j+1, -1)
      _chk = nil
    end
  end

  if not _skip_hd then
	_cnt = _cnt + 1
	answer = answer..data
	if _cnt > _up_thsh then
		cb_disconnected()
    end
  end
end

if not dat.errcode or (dat.errcode ~= '2006' and dat.errcode ~= '2007') then
	if wifi.sta.status() == 5 then
		net.dns.resolve("api.apixu.com", function(sk, ip)
			if (ip == nil) then 
				print("Lost DNS Apixu!")
			else 
				killapixu = tmr.create()
				killapixu:alarm(10000,0,function(_) 
					if conn then
						cb_disconnected()
						print('\n\nConn killed!\n\n')
					end
				end)

				conn=net.createConnection(net.TCP, 0) 
				conn:on("connection", function(conn, payload) conn:send(request.."Connection: close\r\nAccept: /\r\n\r\n") end)
				conn:on("disconnection", cb_disconnected)
				conn:on("receive", data_received)
				conn:connect(80, 'api.apixu.com')
			end
		end)
	end
else
	print('Apixu blocked!', dat.err)
end